// ***************************************************************
// *       GNU style assembly code generated from board.s        *
// ***************************************************************
// * This file is automatically generated by the build process   *
// * from the ARM style assembly file. Editing it is, therefore, *
// * completely futile!  DO NOT EDIT THIS FILE!!!                *
// ***************************************************************
//****************************************************************************
//*                   CONEXANT PROPRIETARY AND CONFIDENTIAL                  *
//*                       SOFTWARE FILE/MODULE HEADER                        *
//*                    Conexant Systems Inc. (c) 1999-2004                   *
//*                           All Rights Reserved                            *
//****************************************************************************
//*                                                                          *
//* Filename:       board.s                                                  *
//*                                                                          *
//* Description:    Board specific routines used during startup sequence.    *
//*                                                                          *
//* Author:         Tim Ross                                                 *
//*                                                                          *
//****************************************************************************
//* $Id$
//****************************************************************************

//******************************************************
//* Conexant (i.e. Conexant Chip-Based) Board Routines *
//******************************************************

//******************
//* Include Files  *
//******************
#include "stbcfg.asmh"
#include "board.asmh"

//********************************
//* External Function Prototypes *
//********************************
    .extern InitUART
    .extern WriteSerial
#if ( EMULATION_LEVEL != PHASE3 ) 
    .extern ClearI2CBus
#endif 

//**********************
//* Local Definitions  *
//**********************

//***************
//* Global Data *
//***************


#if 0
.text 1
.align 4
#else 
.text 1
.align 4
#endif 


//********************************************************************
//*  InitCheckpointOutput                                            *
//*                                                                  *
//*  PARAMETERS:                                                     *
//*      None.                                                       *
//*                                                                  *
//*  DESCRIPTION:                                                    *
//*      Initializes hardware used for outputting checkpoints.       *
//*                                                                  *
//*  RETURNS:                                                        *
//*      Nothing.                                                    *
//*                                                                  *
//*  REGISTER USAGE:                                                 *
//*      r0, r1, r2, r3, r12                                         *
//*                                                                  *
//********************************************************************
    .global InitCheckpointOutput
InitCheckpointOutput: 
    mov r12, lr
#if ( EMULATION_LEVEL != PHASE3 ) 

    //Ensure I2C bus(es) are not stuck!
    mov r0, #0
    bl ClearI2CBus
    mov r0, #1
    bl ClearI2CBus
    mov r0, #2
    bl ClearI2CBus
#endif 
#if SERIAL1 == INTERNAL_UART1  ||  SERIAL1 == INTERNAL_UART2  ||  SERIAL1 == INTERNAL_UART3
        // Initialize serial port
        bl InitUART // Uses r0, r1, r2
#endif // Serial Port Check
#if ( EMULATION_LEVEL != PHASE3 ) 
#if CUSTOMER == CNXT
#if EMULATION_LEVEL == FINAL_HARDWARE


#endif // EMULATION_LEVEL <> FINAL_HARDWARE
#endif // CUSTOMER = CNXT

#endif 
    // Return to Calling Routine
    bx r12


//********************************************************************
//*  Checkpoint                                                      *
//*                                                                  *
//*  DESCRIPTION:                                                    *
//*      Output checkpoint info to board-specific output ports.      *
//*                                                                  *
//*  PARAMETERS:                                                     *
//*      r0 - ptr to unlimited length, null-terminated string for    *
//*           output to more sophisticated device (i.e. serial       *
//*           terminal). If this is NULL, then skip serial output.   *
//*                                                                  *
//*  RETURNS:                                                        *
//*      Nothing.                                                    *
//*                                                                  *
//*  REGISTER USAGE:                                                 *
//*      r0, r1, r2, r3, r12                                         *
//*                                                                  *
//********************************************************************
    .global Checkpoint
Checkpoint: 

    //Save return address
    mov r12, lr
    movs r3, r0 // Save the string pointer                   

    //If NULL string, return
    beq 0f
#if ( EMULATION_LEVEL != PHASE3 ) 

#if SERIAL1 == INTERNAL_UART1  ||  SERIAL1 == INTERNAL_UART2  ||  SERIAL1 == INTERNAL_UART3

        //**************************************
        //* Output full string to serial port. *
        //**************************************
        ldr r1, =RST_SCRATCH_REG // Only output to serial if enabled.
        ldr r2, [r1]
        tst r2, #RST_SCRATCH_SERIAL_CKPT_ENABLE
        blne WriteSerial // Uses r0, r1, r2

#endif // Serial Port Check

#else 
    blne WriteSerial // Uses r0, r1, r2
#endif 

    //Return
0: bx r12 


//********************************************************************
//*  StartupFatalExit                                                *
//*                                                                  *
//*  DESCRIPTION:                                                    *
//*      This routine is called when a problem occurs that will      *
//*      prevent startup from continuing. We output a message using  *
//*      our checkpoint routine and loop forever.                    *
//*                                                                  *
//*  PARAMETERS:                                                     *
//*      r0 - ptr to unlimited length, null-terminated string for    *
//*           output to more sophisticated device (i.e. serial       *
//*           terminal)                                              *
//*                                                                  *
//*  RETURNS:                                                        *
//*      Does not return.                                            *
//*                                                                  *
//*  REGISTER USAGE:                                                 *
//*      r0, r1, r2, r3, r12                                         *
//*                                                                  *
//********************************************************************
    .global StartupFatalExit
StartupFatalExit: 

    //*********************************************************
    //* Output error message details via checkpoint routines. *
    //*********************************************************
    bl Checkpoint

    //*********
    //* Halt. *
    //*********
0: b 0b 


    .end 

//****************************************************************************
//* Modifications:
//* $Log$
//****************************************************************************



