// ***************************************************************
// *       GNU style assembly code generated from /home/sainin/UBS/stb_dev/target/src/cnxt_base/drivers/startup/serial.s*
// ***************************************************************
// * This file is automatically generated by the build process   *
// * from the ARM style assembly file. Editing it is, therefore, *
// * completely futile!  DO NOT EDIT THIS FILE!!!                *
// ***************************************************************
///****************************************************************************/
///*                   CONEXANT PROPRIETARY AND CONFIDENTIAL                  */
///*                       SOFTWARE FILE/MODULE HEADER                        */
///*                    Conexant Systems Inc. (c) 1999-2004                   */
///*                               Austin, TX                                 */
///*                            All Rights Reserved                           */
///****************************************************************************/
///*
// * Filename:       serial.s
// *
// *
// * Description:    Low-level boot serial port support
// *
// *
// * Author:         Tim Ross
// *
// ****************************************************************************/
///* $Id$
// ****************************************************************************/

//******************
//* Include Files  *
//******************
#include "stbcfg.asmh"
#include "serial.asmh"
#include "board.asmh"

//**********************
//* Local Definitions  *
//**********************

// Equation is Div = (Freq/16*Baudrate)-1
#if EMULATION_LEVEL == PHASE3
#define SER_CLOCK_FREQ 25000000
#else 
#define SER_CLOCK_FREQ 54000000
#endif 
#define SER_BAUDRATE_DIV (SER_CLOCK_FREQ/(16*DEFAULT_SERIAL_BAUD_RATE)-1)

//***************
//* Global Data *
//***************
.text 1
.align 4

//**************************************************************************************
//* IMPORTANT:                                                                         *
//*     All of the following code is completely RAM independent. This is crucial       *
//*     to its operation since it is called before RAM has been setup. Only registers  *
//*     r0-r3 are used to ensure it is callable from 'C' code.                         *
//**************************************************************************************

//********************************************************************
//*  InitUART                                                        *
//*                                                                  *
//*  DESCRIPTION:                                                    *
//*      Initialize the UART for outputting messages during startup. *
//*                                                                  *
//*  PARAMETERS:                                                     *
//*      None.                                                       *
//*                                                                  *
//*  RETURNS:                                                        *
//*      Nothing.                                                    *
//*                                                                  *
//*  REGISTER USAGE:                                                 *
//*      r0, r1, r2                                                  *
//*                                                                  *
//********************************************************************
    .global InitUART
InitUART: 

#if EMULATION_LEVEL == FINAL_HARDWARE  ||  EMULATION_LEVEL == PHASE3 
#if (EMULATION_LEVEL == PHASE3)
    //****************************
    //* Set Pin Muxing for UART1 *
    //****************************
    ldr r0, =PLL_PIN_GPIO_MUX0_REG
    ldr r1, [r0]
    orr r1, r1, #GPIO_MUX0_UART_ENABLE
    str r1, [r0]
#endif 

    //******************
    //* Set BAUD rate. *
    //******************
    ldr r0, =SER_BAUDRATE_DIV

    // Enable writing to divisor latch registers for 16550 type UART.
    ldr r1, =SER_LCR
    mov r2, #SER_DIV_LATCH_EN
    str r2, [r1]

    // Write low and high bytes of divisor latch.
    ldr r1, =SER_DLL
    strb r0, [r1]
    mov r0, r0, lsr #8
    ldr r1, =SER_DLH
    strb r0, [r1]

    // Write fractional part in UART expansion register

    //************************
    //* Set line parameters. *
    //************************
    mov r0, #0
    orr r0, r0, #SER_WORD_LEN_8
    orr r0, r0, #SER_STOP_BITS_1
    orr r0, r0, #SER_PARITY_DIS
    orr r0, r0, #SER_BREAK_DIS
    ldr r1, =SER_LCR
    str r0, [r1]


#endif //EMULATION_LEVEL = FINAL_HARDWARE

    bx lr

//********************************************************************
//*  WriteSerial                                                     *
//*                                                                  *
//*  DESCRIPTION:                                                    *
//*      Output string to serial port.                               *
//*                                                                  *
//*  PARAMETERS:                                                     *
//*      r0 - ptr to null-terminated string to output.               *
//*                                                                  *
//*  RETURNS:                                                        *
//*      Nothing.                                                    *
//*                                                                  *
//*  REGISTER USE:                                                   *
//*      r0 - character ptr                                          *
//*      r1 - working register                                       *
//*      r2 - character value                                        *
//********************************************************************
    .global WriteSerial
WriteSerial: 

#if ( EMULATION_LEVEL == FINAL_HARDWARE  ||  EMULATION_LEVEL == PHASE3 )  &&  DEBUG

    //*************************************
    //* Check for NULL end of string and  *
    //* advance ptr to next character.    *
    //*************************************
1:  
    read_byte_from_memory_and_increment r0, r2, r1
    cmp r2, #0
    beq 0f
    
    //*****************************************
    //* Check the UART to see if it is empty. *
    //*****************************************
2: ldr r1, =SER_LSR 
    ldrb r1, [r1]
    
    //******************************************************
    //* We check the FIFO threshold because                *
    //* the TX empty bit (bit 6) in the status register    *
    //* does not seem the properly indicate that           *
    //* the FIFO has room for a character.                 *
    //******************************************************
    tst r1, #SER_TX_FIFO_LOW
    beq 2b

    //****************************
    //* Write the character out. *
    //****************************
    ldr r1, =SER_THR
    strb r2, [r1]

    //****************************
    //* Go on to next character. *
    //****************************
    b 1b

#endif //EMULATION_LEVEL = FINAL_HARDWARE

0: bx lr 

    .end 

///***************************************************************************
//* Modifications:
//* $Log$
//****************************************************************************


