/**
*******************************************************************************
**
** \file      cmd_metz.c
**
** \version   01.00.00
**
** \date      20.03.2009
**
** \author    Juergen Sachs
**
** \brief     U-Boot command for Metz
**
** \attention THIS CODE IS PROVIDED AS IS. AIXSOLVE ACCEPTS NO RESPONSIBILITY
**            OR LIABILITY FOR ANY ERRORS OR OMMISIONS
**
** Copyright (c) 2009 AixSolve GmbH (Germany)
**
*******************************************************************************
*/

//#include "stbcfg.h"

#include <common.h>
#include <command.h>

#include <status_codes.h>

#include "md5sum.h"

/**
*******************************************************************************
**
** \brief 
**
** description
**
** \param 
** \param 
** \return 
**
*******************************************************************************
**/
static void md5sum( unsigned int address, unsigned int len )
{
  MD5_CTX ctx;
  const unsigned char * p;
  const unsigned char * p_end;
  MD5Init( &ctx );
  MD5Update( &ctx, (void*)address, len );
  MD5Final( &ctx );

  printf( "MD5SUM=");
  for( p = ctx.digest, p_end = ctx.digest+16
     ; p < p_end
     ; p++
     )
    printf( "%02x", *p
    );
  printf( "\n" );
}


/**
*******************************************************************************
**
** \brief 
**
** description
**
** \param 
** \param 
** \return 
**
*******************************************************************************
**/
int do_md5sum(cmd_tbl_t * cmdtp, int flag, int argc, char *argv[])
{
  int ret = 0;

  switch( argc )
  {

  case 3:
    {
      unsigned int start, len;
      start = simple_strtoul(argv[1], NULL, 10);
      len   = simple_strtoul(argv[2], NULL, 10);
      md5sum( start, len );
    }
    break;

  default:
    printf( "Usage:\n%s\n", cmdtp->help );
    ret = 1;
    break;
  }

  return ret;
}

U_BOOT_CMD(
  md5sum, 4, 1, do_md5sum
  , "md5sum - checksum calculation\n"
  , "md5sum <addr> <len> - calculate md5sum\n" // klappt!
);
