/*
 *  drivers/mtd/cnxtnfc/nfc_uboot.c
 *
 *  Copyright (C) 2005-2008 Samsung Electronics
 *  Kyungmin Park <kyungmin.park@samsung.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

/*
 * NXP NAND flash controller initialization in U-Boot
 */

#include <common.h>

#include <linux/mtd/compat.h>
#include <linux/mtd/mtd.h>
#include <linux/mtd/nfc.h>

struct mtd_info nfc_mtd;
struct nfc_dev nfc_dev; 

void nfc_init(void)
{
	int ret = 0;

	memset(&nfc_mtd, 0, sizeof(struct mtd_info));
	memset(&nfc_dev, 0, sizeof(struct nfc_dev));
	nfc_mtd.priv = &nfc_dev;

   ret = nfc_scan(&nfc_mtd, 1);
	if(ret)
	{
      printf("NFC Init Failed.[ret=%d]\n", ret);
	}
}
