/****************************************************************************
 *
 *  Conexant Ethernet driver
 *
 *  Copyright (C) 2007 Conexant Systems,Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License, Version 2, as 
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but AS-IS and WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE, TITLE, or 
 *  NONINFRINGEMENT.See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 *
 */
 /****************************************************************************
 * $Id: rtl8201.h 67023 2008-12-09 16:01:12Z swartzwg $
 ****************************************************************************/
#ifndef __CNXT_EMAC_H
#define __CNXT_EMAC_H

/* PHY Registers */
#define PHY_CTRL_REG               0x00
#define PHY_STATUS_REG             0x01
#define PHY_IDENTIFIER_REG1        0x02
#define PHY_IDENTIFIER_REG2        0x03
#define PHY_AUTONEG_ADV_REG        0x4
#define PHY_AUTONEG_LINK_REG       0x5
#define PHY_MIRROR_REG             0x10
#define PHY_STATUS2_REG            0x11

/* Maximum PHY supported */
#define PHY_ADDR_MAX 0x20

#define EMAC_LOCKUP_WAIT          (100000)
#define MAC_ADDR_LEN              6

#define write_reg(regno,val) \
                (*((volatile unsigned long *) (regno))) = (val)

#define read_reg(regno) \
               (*((volatile unsigned long *) (regno)))

unsigned char EMAC0_ADDR[6] = { 0x00, 0x30, 0xCD, 0x01, 0x07, 0x9C };
unsigned char EMAC1_ADDR[6] = { 0x00, 0x55, 0x44, 0x33, 0x22, 0x11 };

int cnxt_initialize(bd_t * bis);
int rtl8201_initialize(struct eth_device *dev,bd_t * bd);
int rtl8201_init(struct eth_device *dev,bd_t * bd);
void rtl8201_halt (struct eth_device *dev);
int rtl8201_tx (struct eth_device *dev, volatile void *buf, int len);
int rtl8201_rx(struct eth_device *dev);
void cnxt_terminate();

#endif

/****************************************************************************
 * Modifications:
 * $Log$
 *
****************************************************************************/
