/**
*******************************************************************************
**
** \file      serial.h
**
** \version   01.00.00
**
** \date      31.03.2009
**
** \author    Juergen Sachs
**
** \brief     modified by aixsolve to support multiple UARTS on NXP
**
** \attention THIS CODE IS PROVIDED AS IS. AIXSOLVE ACCEPTS NO RESPONSIBILITY
**            OR LIABILITY FOR ANY ERRORS OR OMMISIONS
**
** Copyright (c) 2009 AixSolve GmbH (Germany)
**
*******************************************************************************
*/
#ifndef __SERIAL_H__
#define __SERIAL_H__

#define NAMESIZE 16
#define CTLRSIZE 8

struct serial_device {
	char name[NAMESIZE];
	char ctlr[CTLRSIZE];

	int  (*init) (void);
	void (*setbrg) (void);
	int (*getc) (void);
	int (*tstc) (void);
	void (*putc) (const char c);
	void (*puts) (const char *s);

	struct serial_device *next;
};

#if defined(CFG_NS16550_SERIAL)
extern struct serial_device eserial1_device;
extern struct serial_device eserial2_device;
extern struct serial_device eserial3_device;
extern struct serial_device eserial4_device;
#endif /* CFG_NS16550_SERIAL */

extern void serial_initialize(void);
extern void serial_devices_init(void);
extern int serial_assign(char * name);
extern void serial_reinit_all(void);

#endif
